package com.app.kemenhub.jakbanapps.db;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import de.greenrobot.dao.AbstractDao;
import de.greenrobot.dao.Property;
import de.greenrobot.dao.internal.DaoConfig;

import com.app.kemenhub.jakbanapps.db.hotel_fee;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "HOTEL_FEE".
*/
public class hotel_feeDao extends AbstractDao<hotel_fee, Long> {

    public static final String TABLENAME = "HOTEL_FEE";

    /**
     * Properties of entity hotel_fee.<br/>
     * Can be used for QueryBuilder and for referencing column names.
    */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "id", true, "_id");
        public final static Property Provinsi_id = new Property(1, String.class, "provinsi_id", false, "PROVINSI_ID");
        public final static Property Unit = new Property(2, String.class, "unit", false, "UNIT");
        public final static Property Eselon1 = new Property(3, String.class, "eselon1", false, "ESELON1");
        public final static Property Eselon2 = new Property(4, String.class, "eselon2", false, "ESELON2");
        public final static Property Eselon3 = new Property(5, String.class, "eselon3", false, "ESELON3");
        public final static Property Eselon4 = new Property(6, String.class, "eselon4", false, "ESELON4");
        public final static Property Golongan1_2 = new Property(7, String.class, "golongan1_2", false, "GOLONGAN1_2");
    };


    public hotel_feeDao(DaoConfig config) {
        super(config);
    }
    
    public hotel_feeDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(SQLiteDatabase db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"HOTEL_FEE\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: id
                "\"PROVINSI_ID\" TEXT," + // 1: provinsi_id
                "\"UNIT\" TEXT," + // 2: unit
                "\"ESELON1\" TEXT," + // 3: eselon1
                "\"ESELON2\" TEXT," + // 4: eselon2
                "\"ESELON3\" TEXT," + // 5: eselon3
                "\"ESELON4\" TEXT," + // 6: eselon4
                "\"GOLONGAN1_2\" TEXT);"); // 7: golongan1_2
    }

    /** Drops the underlying database table. */
    public static void dropTable(SQLiteDatabase db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"HOTEL_FEE\"";
        db.execSQL(sql);
    }

    /** @inheritdoc */
    @Override
    protected void bindValues(SQLiteStatement stmt, hotel_fee entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
 
        String provinsi_id = entity.getProvinsi_id();
        if (provinsi_id != null) {
            stmt.bindString(2, provinsi_id);
        }
 
        String unit = entity.getUnit();
        if (unit != null) {
            stmt.bindString(3, unit);
        }
 
        String eselon1 = entity.getEselon1();
        if (eselon1 != null) {
            stmt.bindString(4, eselon1);
        }
 
        String eselon2 = entity.getEselon2();
        if (eselon2 != null) {
            stmt.bindString(5, eselon2);
        }
 
        String eselon3 = entity.getEselon3();
        if (eselon3 != null) {
            stmt.bindString(6, eselon3);
        }
 
        String eselon4 = entity.getEselon4();
        if (eselon4 != null) {
            stmt.bindString(7, eselon4);
        }
 
        String golongan1_2 = entity.getGolongan1_2();
        if (golongan1_2 != null) {
            stmt.bindString(8, golongan1_2);
        }
    }

    /** @inheritdoc */
    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    /** @inheritdoc */
    @Override
    public hotel_fee readEntity(Cursor cursor, int offset) {
        hotel_fee entity = new hotel_fee( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // id
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // provinsi_id
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2), // unit
            cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3), // eselon1
            cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4), // eselon2
            cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5), // eselon3
            cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6), // eselon4
            cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7) // golongan1_2
        );
        return entity;
    }
     
    /** @inheritdoc */
    @Override
    public void readEntity(Cursor cursor, hotel_fee entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setProvinsi_id(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setUnit(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
        entity.setEselon1(cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3));
        entity.setEselon2(cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4));
        entity.setEselon3(cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5));
        entity.setEselon4(cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6));
        entity.setGolongan1_2(cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7));
     }
    
    /** @inheritdoc */
    @Override
    protected Long updateKeyAfterInsert(hotel_fee entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    /** @inheritdoc */
    @Override
    public Long getKey(hotel_fee entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    /** @inheritdoc */
    @Override    
    protected boolean isEntityUpdateable() {
        return true;
    }
    
}
